<?php
session_start();
include('config.php');
include($rutaPhp.$rutaHtml.'/maqueta/includes.php');

include_once($rutaPhp.$rutaHtml.'/acceso/control.php');
$esPantallaOP=true;
include_once($rutaPhp.$rutaHtml.'/maqueta/arriba.php');

include($rutaPhp.$rutaHtml.'/librerias/teclado.php'); 

$numAlbaran=$_GET['numalbaran'];

foreach(arreglaArrayPXMobileProxiumResult($_SESSION['orden']['AlbaranesCrossDocking']) as $item) if( $item['NumAlbaran']==$numAlbaran) $albaran=$item;


if($_POST['enviar']==1) {
	
	//SGAPreparar#Empresa#Usuario#PREPARARCROSSDOCKING#Almacen#Empresa;NumOrden;Albaran;Palets

	$peticion='SGAPreparar#'.$_SESSION['empresa'].'#'.$_SESSION['usuario']['Usuario'].'#PREPARARCROSSDOCKING#'.$_SESSION['almacen'].';'.$_SESSION['orden']['Empresa'].';'.$_SESSION['orden']['OrdenPreparacion'].';'.$numAlbaran.';'.$_POST['cadenaPaletsLeidos'];
	
	//$peticion='SGAPreparar#PXCOT#PRU#PREPARARCROSSDOCKING#1;PXCOT;OP2000006;2000008;20082400001,20082400033,20082400003';
	
	$resultado=PedirDatos($wsUsuario,$wsClave,$wsEmpresa,$peticion);
	
	if($_GET['traza']=='si') {
		echo "<p>".$peticion."</p>";
		print_r($resultado);
	}
	
	
	$valores=explode('#',$resultado[0]['Error']);
	
	//echo '<p>Valores:</p>';
	//print_r($valores);
	
	if($valores[0]=='1') {
	
		?>
		<script>
			alert('<?php echo $valores[1]; ?>',null,'error');
        </script>
		<?php
	}
	else if($valores[0]=='0') {
	
		//Volvemos a la pantalla principal
		?>
		<script>
			alert('<?php echo $valores[1]; ?>',null,'ok')
			.done(function(){
				$('#popupCargando').show();
				window.location='orden-preparacion-S.php?orden=<?php echo $_SESSION['orden']['OrdenPreparacion']; ?>&empresa=<?php echo $_SESSION['orden']['Empresa']; ?>';
			});
        </script>
		<?php
	}
	else if($valores[0]=='2') {
	
		?>
		<script>
			$('#popupCargando').show();
			window.location='orden-preparacion-proceso-S.php';
        </script>
		<?php
	
	}
	
}

?>

<script>

	var paletsDisponibles=new Array();
	
	<?php
	$cuantosPalets=0;
	foreach(arreglaArrayPXMobileProxiumResult($albaran['Palets']) as $palet) {
		?>paletsDisponibles.push('<?php echo $palet['IDPalet']; ?>');<?php
		$cuantosPalets++;
	}
	?>

</script>

<h2 style="margin-top:0">Orden de Preparación Nº <?php echo $_SESSION['orden']['OrdenPreparacion']; ?></h2>

<p><strong>Albarán Nº <?php echo $numAlbaran; ?></strong></p>

<p>Proceso de lectura de Ids de Palet por Cross Docking</p>



<form id="formulario" name="form1" method="post" action="">

<div>
	<div id="bloqueLecturaPalet-1" class="campoOrdenPreparacionBloque" style="margin:0 auto"><img src="<?php echo DIR_IMAGENES; ?>/teclado.png" alt="Mostrar teclado" class="iconoTeclado iconoTecladoPalet" id="tecladoPalet-1" contador="1"/><input name="lecturaPalet-1" type="text" class="campo campoOrdenPreparacion lecturaPalet" id="lecturaPalet-1" contador="1" autocomplete="off"/><img src="<?php echo DIR_IMAGENES; ?>/x.png" alt="Borrar" class="campoOrdenPreparacionBorrar borrarPalet" contador="1"/></div>
	<div id="nuevaLecturaPalet-1"></div>
</div>
            
<input type="hidden" id="cantidadMaximaPalets" name="cantidadMaximaPalets" value="<?php echo $cuantosPalets; ?>" />
<input type="hidden" id="cantidad" name="cantidad" value="0" />
<input type="hidden" id="ultimoBloquePalet" name="ultimoBloquePalet" value="1" />
<input type="hidden" id="cadenaPaletsLeidos" name="cadenaPaletsLeidos" style="width:400px" />
<input type="hidden" id="enviar" name="enviar" value="0" />         
            
</form>
  

<script>

	function habilitaBotonPlay(valor) {
	
		if(valor) {
			$('#botonSgteProducto').attr('src','<?php echo DIR_IMAGENES; ?>/botones/play.png');
			$('#botonSgteProducto').removeClass('off');
			$('#botonSgteProducto').addClass('continuar');
		}
		else {
			$('#botonSgteProducto').attr('src','<?php echo DIR_IMAGENES; ?>/botones/play-off.png');
			$('#botonSgteProducto').addClass('off');
			$('#botonSgteProducto').removeClass('continuar');
		}
	
	}
	
	function compruebaLecturacompleta() {
	
		if($('#cantidad').val()==<?php echo $cuantosPalets; ?>) habilitaBotonPlay(true);
		else habilitaBotonPlay(false);
		
	}

	function gestionaPalets() {
	
		var cadena='';
		var cuantos=0;
		$('.lecturaPalet').each(function(){
			if($(this).val()!='') {
				cadena=cadena+$(this).val()+',';
				cuantos++;
			}
		});
		cadena=cadena.substr(0,cadena.length-1);
		$('#cadenaPaletsLeidos').val(cadena);
				
		if(cuantos>0) $('#cantidad').val(cuantos);
		else $('#cantidad').val('');
		
		compruebaLecturacompleta();
	
	}
	
	function construyelecturaPalet(contador) {
					
		var nuevoContador=contador+1;
		
		$('#nuevaLecturaPalet-'+contador).html('<div id="bloqueLecturaPalet-'+nuevoContador+'" class="campoOrdenPreparacionBloque" style="margin:10px auto"><img src="<?php echo DIR_IMAGENES; ?>/teclado.png" alt="Mostrar teclado" class="iconoTeclado iconoTecladoPalet" id="tecladoPalet-'+nuevoContador+'" contador="'+nuevoContador+'"/><input name="lecturaPalet-'+nuevoContador+'" type="text" class="campo campoOrdenPreparacion lecturaPalet" id="lecturaPalet-'+nuevoContador+'" contador="'+nuevoContador+'" autocomplete="off"/><img src="<?php echo DIR_IMAGENES; ?>/x.png" alt="Borrar" class="campoOrdenPreparacionBorrar borrarPalet" contador="'+nuevoContador+'"/></div><div id="nuevaLecturaPalet-'+nuevoContador+'"></div>');
		
		$('#ultimoBloquePalet').val(nuevoContador);
		$('#lecturaPalet-'+nuevoContador).focus();
		
		var posicion = $('#lecturaPalet-'+nuevoContador).offset().top;
		$('html,body').animate({scrollTop:posicion});
		
	}
	
	function paletDisponible(paletsDisponibles,id) {
	
		var encontrado=false;
		var actual;
		
		for (i=0;i<paletsDisponibles.length;i++) {
			actual=paletsDisponibles[i];
			if(actual==id) encontrado=true;
		}
		
		return encontrado;
	
	}




$(document).ready(function() {
	

	
		$(document).on('click','.iconoTecladoPalet',function(){
				
				var contador=$(this).attr('contador');
				
				$('#teclado').show();
				$('#valor').val( $('#lecturaPalet-'+contador).val() );
				$('#valorOculto').val( $('#lecturaPalet-'+contador).val() );
				$('#enter').attr('campoValor','lecturaPalet-'+contador);
				$('#enter').attr('forzarEnter','si');
		});
			
		
		$(document).on('change','.lecturaPalet',function(){
			
				var campo=$(this);
				var contador=campo.attr('contador');
			
				if( !paletDisponible(paletsDisponibles,campo.val()) ) {
					alert('Este Id de Palet no está disponible en este Albarán.')
					.done(function(){
						campo.val('');
						campo.focus();
					});
				}
				else if( $('#cadenaPaletsLeidos').val().indexOf( campo.val() ) != -1 ) {
					alert('Este Id de Palet ya está leido en la serie actual.')
					.done(function(){
						campo.val('');
						campo.focus();
					});
				}
				else {
					
					$(this).attr('readonly','readonly');
					$('#tecladoPalet-'+contador).hide();
					
					gestionaPalets();
						
					//var contador=parseInt( $(this).attr('contador') );
					var contador=parseInt( $('#ultimoBloquePalet').val() );
							
					if( parseInt($('#cantidad').val()) < parseInt( $('#cantidadMaximaPalets').val() ) ) {
							
						construyelecturaPalet(contador);
							
					}
				}
				

				
		});
			
			$(document).on('click','.borrarPalet',function(){
			
				var contador=parseInt($(this).attr('contador'));
				var ultimoBloquePalet=parseInt($('#ultimoBloquePalet').val());
				var cantidadMaximaPalets=parseInt($('#cantidadMaximaPalets').val());
				var cantidadActual=parseInt($('#cantidad').val());
				
				if($('#lecturaPalet-'+contador).val() != '') {
				
					$('#lecturaPalet-'+contador).val('');
					
					if( contador!=ultimoBloquePalet ) $('#bloqueLecturaPalet-'+contador).hide();
					
					gestionaPalets();
					
					if( $( '#lecturaPalet-'+ultimoBloquePalet ).val() != '' ) {
					
						if( cantidadActual < cantidadMaximaPalets ) {
						
							construyelecturaPalet(ultimoBloquePalet);
						}
					
					}
					
					$('#lecturaPalet-'+ultimoBloquePalet).focus();
					$('#lecturaPalet-'+ultimoBloquePalet).removeAttr('readonly');
				
				}
				else {
					$('#lecturaPalet-'+contador).focus();
					$('#lecturaPalet-'+contador).removeAttr('readonly');
				}
				
				compruebaLecturacompleta();
			
			});
			

	

	
	
	$('#botonPausar').on("click",function(e){
		e.preventDefault();
		window.location='<?php echo $rutaHtml; ?>/ordenes-preparacion.php';	
	});
	
	$('#formulario').on("submit",function(e){
	
		if($('#enviar').val()!=1) e.preventDefault();
	
	});
	
	$('.continuar').on("click",function(e){
			
		e.preventDefault();
			
		if( !$(this).hasClass('off') ) {
		
			$('#popupCargando').show();
			$('#enviar').val(1);
			$('#formulario').submit();
			
		}
			
	});
	
	
	habilitaBotonPlay(false);
	$('#lecturaPalet-1').focus();
	
});




</script>

<?php

$mostrarInfo=true;

include($rutaPhp.$rutaHtml.'/maqueta/menu-orden-preparacion-S.php');

include($rutaPhp.$rutaHtml.'/maqueta/abajo.php');
?>
